<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 30/04/2018
 * Time: 13:30
 */

namespace Service\Hcm;

class EventoService {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }
    
    public function getEvento($nrorg, $nrorgtrab, $dtmescompetenc, $nreventom){
        try {
            $query = <<<SQL
SELECT EM.*
  FROM FPA_EVENTOM EM
  JOIN FPA_EVENTOH EH ON EH.NRORG = EM.NRORG
                     AND EH.NREVENTOM = EM.NREVENTOM
                     AND EH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM FPA_EVENTOH H1
                                                WHERE H1.NREVENTOM = EH.NREVENTOM
                                                  AND H1.NRORG = EH.NRORG
                                                  AND TRUNC(H1.DTMESCOMPETENC,'DD') <= TO_DATE(:P_DTMESCOMPETENC,'DD/MM/YYYY'))
 WHERE (EM.NRORG = :P_NRORG OR EM.NRORG = :P_NRORGTRAB)
   AND EM.NREVENTOM = :P_NREVENTOM
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_NRORGTRAB' => $nrorgtrab,
                'P_DTMESCOMPETENC' => $dtmescompetenc,
                'P_NREVENTOM' => $nreventom,
            );
            $result = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getLotelancevento($nrorg, $dslotelancevento, $dtcompetloteeve, $nrtipomoviment){
        try {
            $query = <<<SQL
SELECT *
  FROM FPA_LOTELANCEVENTO
 WHERE NRORG = :P_NRORG
   AND DSLOTELANCEVENTO = :P_DSLOTELANCEVENTO
   AND DTCOMPETLOTEEVE = TO_DATE(:P_DTCOMPETLOTEEVE,'DD/MM/YYYY')
   AND NRTIPOMOVIMENT = :P_NRTIPOMOVIMENT
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_DSLOTELANCEVENTO' => $dslotelancevento,
                'P_DTCOMPETLOTEEVE' => $dtcompetloteeve,
                'P_NRTIPOMOVIMENT' => $nrtipomoviment,
            );
            $result = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getItemlotelanc($nrorg, $nrlotelancevento, $nrvinculom, $nreventom, $dtocorrencia){
        try {
            $query = <<<SQL
SELECT *
  FROM FPA_ITEMLOTELANC
 WHERE NRORG = :P_NRORG
   AND NRLOTELANCEVENTO = :P_NRLOTELANCEVENTO
   AND NRVINCULOM = :P_NRVINCULOM
   AND NREVENTOM = :P_NREVENTOM
   AND DTOCORRENCIA = TO_DATE(:P_DTOCORRENCIA, 'DD/MM/YYYY')
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_NRLOTELANCEVENTO' => $nrlotelancevento,
                'P_NRVINCULOM' => $nrvinculom,
                'P_NREVENTOM' => $nreventom,
                'P_DTOCORRENCIA' => $dtocorrencia,
            );
            $result = $this->entityManager->getConnection()->fetchAll($query, $params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function addLotelancevento($nrorg, $nrlotelancevento, $dslotelancevento, $dtcompetloteeve, $nrtipomoviment, $dsobslotelanc, $cdoperador){
        try {
            $sql = <<<SQL
INSERT INTO FPA_LOTELANCEVENTO
    (NRORG, NRLOTELANCEVENTO, DSLOTELANCEVENTO, DTCOMPETLOTEEVE, NRTIPOMOVIMENT, DSOBSLOTELANC, NRORGINCLUSAO, CDOPERINCLUSAO, DTLOTELANCEVENTO, DTINCLUSAO, IDORIGLOTELANC, DTOCORRENCIA)
VALUES 
    (:NRORG, :NRLOTELANCEVENTO, :DSLOTELANCEVENTO, TO_DATE(:DTCOMPETLOTEEVE,'DD/MM/YYYY'), :NRTIPOMOVIMENT, :DSOBSLOTELANC, :NRORGINCLUSAO, :CDOPERINCLUSAO, TRUNC(SYSDATE), SYSDATE, :IDORIGLOTELANC, TRUNC(SYSDATE))
SQL;
            $params = array(
                'NRORG' => $nrorg,
                'NRLOTELANCEVENTO' => $nrlotelancevento,
                'DSLOTELANCEVENTO' => $dslotelancevento,
                'DTCOMPETLOTEEVE' => $dtcompetloteeve,
                'NRTIPOMOVIMENT' => $nrtipomoviment,
                'DSOBSLOTELANC' => $dsobslotelanc,
                'NRORGINCLUSAO' => $nrorg,
                'CDOPERINCLUSAO' => $cdoperador,
                'IDORIGLOTELANC' => 'HCMSERVICES',
            );
            $result = $this->entityManager->getConnection()->prepare($sql)->execute($params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function addItemLotelanc($nrorg, $nrlotelancevento, $nritemlotelanc, $nrvinculom, $nreventom, $vrreffolhalote, $vreventolote,
                                    $dtocorrencia, $dsobservacao, $cdoperador){
        try {
            $sql = <<<SQL
INSERT INTO FPA_ITEMLOTELANC
    (NRORG, NRLOTELANCEVENTO, NRITLOTELANC, NRVINCULOM, NREVENTOM, VRREFFOLHALOTE, VREVENTOLOTE, DTOCORRENCIA, DSOBSERVACAO, NRORGINCLUSAO, CDOPERINCLUSAO, DTINCLUSAO)
VALUES 
    (:NRORG, :NRLOTELANCEVENTO, :NRITLOTELANC, :NRVINCULOM, :NREVENTOM, :VRREFFOLHALOTE, :VREVENTOLOTE, TO_DATE(:DTOCORRENCIA,'DD/MM/YYYY'), :DSOBSERVACAO, :NRORGINCLUSAO, :CDOPERINCLUSAO, SYSDATE)
SQL;
            $params = array(
                'NRORG' => $nrorg,
                'NRLOTELANCEVENTO' => $nrlotelancevento,
                'NRITLOTELANC' => $nritemlotelanc,
                'NRVINCULOM' => $nrvinculom,
                'NREVENTOM' => $nreventom,
                'VRREFFOLHALOTE' => $vrreffolhalote,
                'VREVENTOLOTE' => $vreventolote,
                'DTOCORRENCIA' => $dtocorrencia,
                'DSOBSERVACAO' => $dsobservacao,
                'NRORGINCLUSAO' => $nrorg,
                'CDOPERINCLUSAO' => $cdoperador,
            );
            $result = $this->entityManager->getConnection()->prepare($sql)->execute($params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function updateItemLotelanc($nrorg, $nritemlotelanc, $nrlotelancevento, $vrreffolhalote, $vreventolote, $cdoperador){
        try {
            $sql = <<<SQL
UPDATE FPA_ITEMLOTELANC
   SET VRREFFOLHALOTE = :VRREFFOLHALOTE,
       VREVENTOLOTE = :VREVENTOLOTE,
       CDOPERULTATU = :CDOPERULTATU,
       DTULTATU = SYSDATE
 WHERE NRORG = :NRORG
   AND NRITLOTELANC = :NRITLOTELANC
   AND NRLOTELANCEVENTO = :NRLOTELANCEVENTO
SQL;
            $params = array(
                'NRORG' => $nrorg,
                'NRITLOTELANC' => $nritemlotelanc,
                'NRLOTELANCEVENTO' => $nrlotelancevento,
                'VRREFFOLHALOTE' => $vrreffolhalote,
                'VREVENTOLOTE' => $vreventolote,
                'CDOPERULTATU' => $cdoperador,
            );
            $result = $this->entityManager->getConnection()->prepare($sql)->execute($params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }
}