create or replace
PROCEDURE ETL_ADMREDE ( P_DTINI IN DATE,
                        P_DTFINA IN DATE)
                                          
                                          
IS

 V_MES          VARCHAR2(2);
 V_ANO          VARCHAR2(4);
 V_TIPOSOLI     VARCHAR2(10);
 V_DTINI        DATE;
 V_DTFINAL      DATE;
 V_CDOPERRESP   VARCHAR2(12);
 V_TEMPO        FLOAT(126);
 V_TEMP         FLOAT;
 V_DATA         DATE;
 V_CDOPER       VARCHAR2(126);
 V_CONT         NUMBER := 0;
 C_PENDENTE     NUMBER := 0;
 V_DIAS         NUMBER;
 V_CDFASE       VARCHAR2(3);
 V_CDOPERTMP    VARCHAR2(12);
 V_CDOPRESPTMP  VARCHAR2(12);
 V_CDFASETRAM   VARCHAR2(3);   
 

BEGIN

    V_DTINI := TO_DATE('01'||TO_CHAR(P_DTINI,'MMYYYY'), 'DDMMYYYY');
    V_MES := TO_CHAR(P_DTINI, 'MM');
    V_ANO := TO_CHAR(P_DTINI, 'YYYY');
    
    DELETE FROM ETLADMREDE
      WHERE ( CDANOBI > V_ANO ) OR
            ( CDANOBI = V_ANO 
            AND CDMESBI >= V_MES );
    
    WHILE ( V_DTINI <= P_DTFINA ) LOOP
    
       V_DTFINAL := LAST_DAY( V_DTINI );
       
--____________________________________________________________________________--
                --SELECIONA TODAS AS SOLICITAES ABERTAS--
          FOR S IN
          (
          
            SELECT CDCLIENTE, CDFILIAL, NRSOLISERV, DSREFESOLI, DTABERSOLI, CDSETOR, CDPRODCOMP,
                   COUNT (DISTINCT NRSOLISERV) AS QTSOLI
              FROM SOLISERV
            WHERE DTABERSOLI BETWEEN V_DTINI AND (V_DTFINAL + 1)
              AND CDASSUNTO = '06000'
              --AND NRSOLISERV = '0000073802'
            GROUP BY CDCLIENTE, CDFILIAL, NRSOLISERV, DSREFESOLI, DTABERSOLI, CDSETOR, CDPRODCOMP
          
          )
          LOOP
--____________________________________________________________________________--
                 -- ULTIMA DATA DA FASE 399--
              BEGIN
               SELECT MAX(DTALFASETRAM), CDFASETRAM
                INTO V_DATA, V_CDFASETRAM
                FROM LOGFASETRAM L
               WHERE CDFASETRAM = '399'
                 AND L.NRSOLISERV = S.NRSOLISERV
               GROUP BY CDFASETRAM;
              EXCEPTION
              WHEN OTHERS THEN
                V_DATA := NULL;
                V_CDFASETRAM := '0';
              END;              
              
--____________________________________________________________________________--
                       --INICIO CALCULO DAS HORAS--
--____________________________________________________________________________--
                              --COM FASE3 99--
                              
                  IF V_CDFASETRAM = '399' THEN
                  
                    /*ULTIMA FASE DEPOIS DA ULTIMA 399*/                  
                   BEGIN
                    SELECT CDOPERRESP, CDFASETRAM 
                      INTO V_CDOPERRESP, V_CDFASE
                      FROM LOGFASETRAM L
                    WHERE L.NRSOLISERV = S.NRSOLISERV
                      AND DTALFASETRAM = ( SELECT  MIN(DTALFASETRAM)
                                          FROM LOGFASETRAM LO
                                         WHERE LO.DTALFASETRAM >= V_DATA
                                           AND LO.NRSOLISERV = S.NRSOLISERV
                                           AND CDFASETRAM <> '399'
                                       );
                    EXCEPTION
                    WHEN OTHERS THEN
                     V_CDOPERRESP := '0';
                     V_CDFASE := '0';
                   END;
                    
                    
                    SELECT COUNT(O.CDOPERADOR)
                     INTO V_CONT
                     FROM FUNCIONARIO F, OPERADOR O
                   WHERE CDEQUIPETRAB LIKE '%1000'
                     AND F.CDFUNC = O.CDFUNC
                     AND O.CDOPERADOR = V_CDOPERRESP;
                     
--Verifica se depois da ultima 399 o solicitao retorna a Administrao de rede--
              /*INICIO DO CALCULO CASO TENHA RETORNADO "PENDENTE"*/
              
                     IF V_CONT > 0 AND V_CDFASE <> '101' THEN 
                     /*NUMERO DE FERIADOS*/
                      BEGIN 
                       SELECT (COUNT(*)) * 600
                        INTO V_DIAS
                        FROM FERIFILI
                       WHERE CDFILIAL = S.CDFILIAL
                        AND DTFERIFILI BETWEEN S.DTABERSOLI AND SYSDATE;
                      END;
                     
                      IF ((S.DTABERSOLI) - TRUNC(S.DTABERSOLI)) > (18/24) THEN /*Verifica se a hora de abertura da solicito foi aberta depois das 18:00 */ 
                       V_TEMPO := (((((SYSDATE) - TRUNC(SYSDATE)) - (8/24))*24) *60);
                       V_TEMPO := (V_TEMPO + ((((TRUNC(SYSDATE) - TRUNC(S.DTABERSOLI))-1) *10) *60)) - V_DIAS;
                      ELSE 
                       V_TEMPO := (((18/24) - ((S.DTABERSOLI) - TRUNC(S.DTABERSOLI))) *24) * 60;
                       V_TEMPO := V_TEMPO + (((((SYSDATE) - TRUNC(SYSDATE)) - (8/24))*24) *60);
                       V_TEMPO := (V_TEMPO + ((((TRUNC(SYSDATE) - TRUNC(S.DTABERSOLI))-1) *10) *60)) - V_DIAS;
                      END IF;
                       
                       C_PENDENTE := 1;
                     ELSE /*FIM DO CALCULO PENDENTE E INICIO DA NO PENDENTE*/ 
                     
                        BEGIN 
                         SELECT (COUNT(*)) * 600
                           INTO V_DIAS
                          FROM FERIFILI
                         WHERE CDFILIAL = S.CDFILIAL
                           AND DTFERIFILI BETWEEN S.DTABERSOLI AND V_DATA;
                        END;
                        
                      IF TRUNC(V_DATA) = TRUNC(S.DTABERSOLI) THEN/*VERIFICA SE A DATA DE ABERTURA DA SOLICITAO E IGUAL A DA DE ENCERRAMENTO*/
                        V_TEMPO := ((V_DATA - S.DTABERSOLI) *24) *60;
                      ELSE
                       IF ((S.DTABERSOLI) - TRUNC(S.DTABERSOLI)) > (18/24) THEN
                        V_TEMPO := (((((V_DATA) - TRUNC(V_DATA)) - (8/24))*24) *60);
                        V_TEMPO := (V_TEMPO + ((((TRUNC(V_DATA) - TRUNC(S.DTABERSOLI))-1) * 10) *60)) - V_DIAS; 
                       ELSE
                        V_TEMPO := (((18/24) - ((S.DTABERSOLI) - TRUNC(S.DTABERSOLI))) *24) * 60;
                        V_TEMPO := V_TEMPO + (((((V_DATA) - TRUNC(V_DATA)) - (8/24))*24) *60);
                        V_TEMPO := (V_TEMPO + ((((TRUNC(V_DATA) - TRUNC(S.DTABERSOLI))-1) * 10) *60)) - V_DIAS;
                       END IF;     
                      END IF;
                        
                       
                     END IF;
                   
                   SELECT CDOPERADOR
                     INTO V_CDOPER
                     FROM LOGFASETRAM LO
                   WHERE CDFASETRAM = '399'
                     AND LO.NRSOLISERV = S.NRSOLISERV
                     AND LO.DTALFASETRAM = V_DATA;
                     
                                                                          
                  ELSE 
                   SELECT CDFASETRAM, CDOPERADOR, CDOPERRESP, DTALFASETRAM
                     INTO V_CDFASE, V_CDOPERTMP, V_CDOPRESPTMP, V_DATA
                     FROM LOGFASETRAM 
                   WHERE NRSOLISERV = S.NRSOLISERV
                     AND DTALFASETRAM = ( SELECT MAX(DTALFASETRAM)
                                            FROM LOGFASETRAM
                                          WHERE NRSOLISERV = S.NRSOLISERV
                                        );
                                        
                        
                     
                   IF V_CDFASE = '101' THEN
                        
                        BEGIN 
                           SELECT (COUNT(*)) * 600
                            INTO V_DIAS
                            FROM FERIFILI
                          WHERE CDFILIAL = S.CDFILIAL
                          AND DTFERIFILI BETWEEN S.DTABERSOLI AND V_DATA;
                        END;
                   
                      IF TRUNC(V_DATA) = TRUNC(S.DTABERSOLI) THEN
                        V_TEMPO := ((V_DATA - S.DTABERSOLI) *24) *60;
                      ELSE
                        IF ((S.DTABERSOLI) - TRUNC(S.DTABERSOLI)) > (18/24) THEN
                          V_TEMPO := (((((V_DATA) - TRUNC(V_DATA)) - (8/24))*24) *60);
                          V_TEMPO := (V_TEMPO + ((((TRUNC(V_DATA) - TRUNC(S.DTABERSOLI))-1) * 10) *60)) - V_DIAS; 
                        ELSE
                          V_TEMPO := (((18/24) - ((S.DTABERSOLI) - TRUNC(S.DTABERSOLI))) *24) * 60;
                          V_TEMPO := V_TEMPO + (((((V_DATA) - TRUNC(V_DATA)) - (8/24))*24) *60);
                          V_TEMPO := (V_TEMPO + ((((TRUNC(V_DATA) - TRUNC(S.DTABERSOLI))-1) * 10) *60)) - V_DIAS;
                        END IF;
                      END IF;
                        
                   ELSE
                     BEGIN
                      SELECT (COUNT(*)) * 600
                         INTO V_DIAS
                       FROM FERIFILI
                      WHERE CDFILIAL = S.CDFILIAL
                        AND DTFERIFILI BETWEEN S.DTABERSOLI AND SYSDATE;
                     END;
                      
                      IF ((S.DTABERSOLI) - TRUNC(S.DTABERSOLI)) > (18/24) THEN
                       V_TEMPO := (((((SYSDATE) - TRUNC(SYSDATE)) - (8/24))*24) *60);
                       V_TEMPO := (V_TEMPO + ((((TRUNC(SYSDATE) - TRUNC(S.DTABERSOLI))-1) *10) *60))- V_DIAS;
                      ELSE
                       V_TEMPO := (((18/24) - ((S.DTABERSOLI) - TRUNC(S.DTABERSOLI))) *24) * 60;
                       V_TEMPO := V_TEMPO + (((((SYSDATE) - TRUNC(SYSDATE)) - (8/24))*24) *60);
                       V_TEMPO := (V_TEMPO + ((((TRUNC(SYSDATE) - TRUNC(S.DTABERSOLI))-1) *10) *60)) - V_DIAS;
                      END IF;
                      
                      C_PENDENTE := 1;
                      V_CDOPER := 0;
                   END IF;
                   
                    IF V_CDFASE = '026' THEN
                      V_CDOPERRESP := V_CDOPRESPTMP;
                    ELSE 
                      V_CDOPERRESP := V_CDOPERTMP; 
                    END IF;
                      
                  
                  END IF; /*FIM CALCULO DAS HORAS*/
                  
                  IF C_PENDENTE = 0 THEN
                     V_TIPOSOLI := 'CONCLUIDA';
                  ELSE
                     V_TIPOSOLI := 'PENDENTE';
                  END IF;
                  
                  
                 IF V_CDFASETRAM = '0' THEN 
                  INSERT INTO ETLADMREDE
                  (
                   CDCLIENTE, CDSETOR, CDPRODCOMP, CDOPERADOR, 
                   NRSOLISERV, QTSOLIABER, QTSOLIPEND, NRHRSOLI,
                   NMSTATSOLI, CDMESBI, CDANOBI, CDEQUIPETRAB
                  )
                  VALUES
                  (
                  
                  S.CDCLIENTE, S.CDSETOR, S.CDPRODCOMP, V_CDOPERRESP, 
                  S.NRSOLISERV, S.QTSOLI, C_PENDENTE, V_TEMPO,
                  V_TIPOSOLI, V_MES, V_ANO, (SELECT MAX(F.CDEQUIPETRAB)
                                               FROM FUNCIONARIO F, OPERADOR O
                                              WHERE O.CDOPERADOR = V_CDOPERRESP
                                                AND F.CDEMPRESA = O.CDEMPRESA
                                                AND F.CDFUNC = O.CDFUNC)
                  );
                  ELSE
                  INSERT INTO ETLADMREDE
                  (
                   CDCLIENTE, CDSETOR, CDPRODCOMP, CDOPERADOR, 
                   NRSOLISERV, QTSOLIABER, QTSOLIPEND, NRHRSOLI,
                   NMSTATSOLI, CDMESBI, CDANOBI, CDEQUIPETRAB
                  )
                  VALUES
                  (
                  
                  S.CDCLIENTE, S.CDSETOR, S.CDPRODCOMP, V_CDOPER,
                  S.NRSOLISERV, S.QTSOLI, C_PENDENTE, V_TEMPO,
                  V_TIPOSOLI, V_MES, V_ANO, (SELECT MAX(F.CDEQUIPETRAB)
                                               FROM FUNCIONARIO F, OPERADOR O
                                              WHERE O.CDOPERADOR = V_CDOPER
                                                AND F.CDEMPRESA = O.CDEMPRESA
                                                AND F.CDFUNC = O.CDFUNC)
                  );
                 END IF;
                 
                 
                  C_PENDENTE := 0;
     
          END LOOP;
          
          COMMIT;
          
         V_DTINI := ADD_MONTHS(V_DTINI, 1);
         V_MES := TO_CHAR(V_DTINI, 'MM');
         V_ANO := TO_CHAR(V_DTINI, 'YYYY');
          
    END LOOP;      

END;
