/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SUBGRUPPROD                                              */
/* Tabela : SUBGRUPPROD                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SUBGRUPPROD' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SUBGRUPPROD
GO

CREATE TRIGGER DTULTATU_SUBGRUPPROD
ON SUBGRUPPROD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SUBGRUPPROD', null, 'CDGRUPPROD=' + CDGRUPPROD + ';'+
                                          'CDSUBGRPROD='+ CDSUBGRPROD+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SUBGRUPPROD
      SET DTULTATUSUGP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(SUBGRUPPROD.CDSUBGRPROD,0)  = ISNULL(INSERTED.CDSUBGRPROD,0))  AND
            (ISNULL(SUBGRUPPROD.IDTPGRPRALIM,0) = ISNULL(INSERTED.IDTPGRPRALIM,0)) AND
            (ISNULL(SUBGRUPPROD.NMSUBGRPROD,0)  = ISNULL(INSERTED.NMSUBGRPROD,0));
   END;
END;
GO

