/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATUAGER                                                      */
/* Tabela : AREAGERE                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 26/02/2007- Arnaldo Coutinho Brito Jnior                                  */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATUAGER' and
            type = 'TR'                      and
            u.uid = o.uid           	     and
            u.name = USER)
   DROP TRIGGER DTULTATUAGER
GO

CREATE TRIGGER DTULTATUAGER
ON AREAGERE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'AREAGERE', null, 'CDAREAGERE=' + CDAREAGERE + ';',                                     GETDATE() FROM DELETED)

   END
   ELSE BEGIN
      UPDATE AREAGERE
      SET DTULTATUAGER = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(AREAGERE.CDAREAGERE,0) = ISNULL(INSERTED.CDAREAGERE,0)) AND                          (ISNULL(AREAGERE.NMAREAGERE,0) = ISNULL(INSERTED.NMAREAGERE,0));
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATUAGER','4.11.072';
GO

